<?php

namespace ArtabanMarketplace\Model\Map;

use ArtabanMarketplace\Model\AmpSellerOrder;
use ArtabanMarketplace\Model\AmpSellerOrderQuery;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\InstancePoolTrait;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\DataFetcher\DataFetcherInterface;
use Propel\Runtime\Exception\PropelException;
use Propel\Runtime\Map\RelationMap;
use Propel\Runtime\Map\TableMap;
use Propel\Runtime\Map\TableMapTrait;


/**
 * This class defines the structure of the 'amp_seller_order' table.
 *
 *
 *
 * This map class is used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 */
class AmpSellerOrderTableMap extends TableMap
{
    use InstancePoolTrait;
    use TableMapTrait;
    /**
     * The (dot-path) name of this class
     */
    const CLASS_NAME = 'ArtabanMarketplace.Model.Map.AmpSellerOrderTableMap';

    /**
     * The default database name for this class
     */
    const DATABASE_NAME = 'thelia';

    /**
     * The table name for this class
     */
    const TABLE_NAME = 'amp_seller_order';

    /**
     * The related Propel class for this table
     */
    const OM_CLASS = '\\ArtabanMarketplace\\Model\\AmpSellerOrder';

    /**
     * A class that can be returned by this tableMap
     */
    const CLASS_DEFAULT = 'ArtabanMarketplace.Model.AmpSellerOrder';

    /**
     * The total number of columns
     */
    const NUM_COLUMNS = 16;

    /**
     * The number of lazy-loaded columns
     */
    const NUM_LAZY_LOAD_COLUMNS = 0;

    /**
     * The number of columns to hydrate (NUM_COLUMNS - NUM_LAZY_LOAD_COLUMNS)
     */
    const NUM_HYDRATE_COLUMNS = 16;

    /**
     * the column name for the ID field
     */
    const ID = 'amp_seller_order.ID';

    /**
     * the column name for the ORDER_ID field
     */
    const ORDER_ID = 'amp_seller_order.ORDER_ID';

    /**
     * the column name for the AMP_SELLER_ID field
     */
    const AMP_SELLER_ID = 'amp_seller_order.AMP_SELLER_ID';

    /**
     * the column name for the CUSTOMER_ID field
     */
    const CUSTOMER_ID = 'amp_seller_order.CUSTOMER_ID';

    /**
     * the column name for the ORDER_PRODUCT_ID field
     */
    const ORDER_PRODUCT_ID = 'amp_seller_order.ORDER_PRODUCT_ID';

    /**
     * the column name for the AMP_SELLER_ORDER_COUNTER field
     */
    const AMP_SELLER_ORDER_COUNTER = 'amp_seller_order.AMP_SELLER_ORDER_COUNTER';

    /**
     * the column name for the SELLER_ORDER_REF field
     */
    const SELLER_ORDER_REF = 'amp_seller_order.SELLER_ORDER_REF';

    /**
     * the column name for the DISCOUNT field
     */
    const DISCOUNT = 'amp_seller_order.DISCOUNT';

    /**
     * the column name for the POSTAGE field
     */
    const POSTAGE = 'amp_seller_order.POSTAGE';

    /**
     * the column name for the POSTAGE_TAX field
     */
    const POSTAGE_TAX = 'amp_seller_order.POSTAGE_TAX';

    /**
     * the column name for the STATUS_ID field
     */
    const STATUS_ID = 'amp_seller_order.STATUS_ID';

    /**
     * the column name for the CREATED_AT field
     */
    const CREATED_AT = 'amp_seller_order.CREATED_AT';

    /**
     * the column name for the UPDATED_AT field
     */
    const UPDATED_AT = 'amp_seller_order.UPDATED_AT';

    /**
     * the column name for the VERSION field
     */
    const VERSION = 'amp_seller_order.VERSION';

    /**
     * the column name for the VERSION_CREATED_AT field
     */
    const VERSION_CREATED_AT = 'amp_seller_order.VERSION_CREATED_AT';

    /**
     * the column name for the VERSION_CREATED_BY field
     */
    const VERSION_CREATED_BY = 'amp_seller_order.VERSION_CREATED_BY';

    /**
     * The default string format for model objects of the related table
     */
    const DEFAULT_STRING_FORMAT = 'YAML';

    /**
     * holds an array of fieldnames
     *
     * first dimension keys are the type constants
     * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
     */
    protected static $fieldNames = array (
        self::TYPE_PHPNAME       => array('Id', 'OrderId', 'AmpSellerId', 'CustomerId', 'OrderProductId', 'AmpSellerOrderCounter', 'SellerOrderRef', 'Discount', 'Postage', 'PostageTax', 'StatusId', 'CreatedAt', 'UpdatedAt', 'Version', 'VersionCreatedAt', 'VersionCreatedBy', ),
        self::TYPE_STUDLYPHPNAME => array('id', 'orderId', 'ampSellerId', 'customerId', 'orderProductId', 'ampSellerOrderCounter', 'sellerOrderRef', 'discount', 'postage', 'postageTax', 'statusId', 'createdAt', 'updatedAt', 'version', 'versionCreatedAt', 'versionCreatedBy', ),
        self::TYPE_COLNAME       => array(AmpSellerOrderTableMap::ID, AmpSellerOrderTableMap::ORDER_ID, AmpSellerOrderTableMap::AMP_SELLER_ID, AmpSellerOrderTableMap::CUSTOMER_ID, AmpSellerOrderTableMap::ORDER_PRODUCT_ID, AmpSellerOrderTableMap::AMP_SELLER_ORDER_COUNTER, AmpSellerOrderTableMap::SELLER_ORDER_REF, AmpSellerOrderTableMap::DISCOUNT, AmpSellerOrderTableMap::POSTAGE, AmpSellerOrderTableMap::POSTAGE_TAX, AmpSellerOrderTableMap::STATUS_ID, AmpSellerOrderTableMap::CREATED_AT, AmpSellerOrderTableMap::UPDATED_AT, AmpSellerOrderTableMap::VERSION, AmpSellerOrderTableMap::VERSION_CREATED_AT, AmpSellerOrderTableMap::VERSION_CREATED_BY, ),
        self::TYPE_RAW_COLNAME   => array('ID', 'ORDER_ID', 'AMP_SELLER_ID', 'CUSTOMER_ID', 'ORDER_PRODUCT_ID', 'AMP_SELLER_ORDER_COUNTER', 'SELLER_ORDER_REF', 'DISCOUNT', 'POSTAGE', 'POSTAGE_TAX', 'STATUS_ID', 'CREATED_AT', 'UPDATED_AT', 'VERSION', 'VERSION_CREATED_AT', 'VERSION_CREATED_BY', ),
        self::TYPE_FIELDNAME     => array('id', 'order_id', 'amp_seller_id', 'customer_id', 'order_product_id', 'amp_seller_order_counter', 'seller_order_ref', 'discount', 'postage', 'postage_tax', 'status_id', 'created_at', 'updated_at', 'version', 'version_created_at', 'version_created_by', ),
        self::TYPE_NUM           => array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, )
    );

    /**
     * holds an array of keys for quick access to the fieldnames array
     *
     * first dimension keys are the type constants
     * e.g. self::$fieldKeys[self::TYPE_PHPNAME]['Id'] = 0
     */
    protected static $fieldKeys = array (
        self::TYPE_PHPNAME       => array('Id' => 0, 'OrderId' => 1, 'AmpSellerId' => 2, 'CustomerId' => 3, 'OrderProductId' => 4, 'AmpSellerOrderCounter' => 5, 'SellerOrderRef' => 6, 'Discount' => 7, 'Postage' => 8, 'PostageTax' => 9, 'StatusId' => 10, 'CreatedAt' => 11, 'UpdatedAt' => 12, 'Version' => 13, 'VersionCreatedAt' => 14, 'VersionCreatedBy' => 15, ),
        self::TYPE_STUDLYPHPNAME => array('id' => 0, 'orderId' => 1, 'ampSellerId' => 2, 'customerId' => 3, 'orderProductId' => 4, 'ampSellerOrderCounter' => 5, 'sellerOrderRef' => 6, 'discount' => 7, 'postage' => 8, 'postageTax' => 9, 'statusId' => 10, 'createdAt' => 11, 'updatedAt' => 12, 'version' => 13, 'versionCreatedAt' => 14, 'versionCreatedBy' => 15, ),
        self::TYPE_COLNAME       => array(AmpSellerOrderTableMap::ID => 0, AmpSellerOrderTableMap::ORDER_ID => 1, AmpSellerOrderTableMap::AMP_SELLER_ID => 2, AmpSellerOrderTableMap::CUSTOMER_ID => 3, AmpSellerOrderTableMap::ORDER_PRODUCT_ID => 4, AmpSellerOrderTableMap::AMP_SELLER_ORDER_COUNTER => 5, AmpSellerOrderTableMap::SELLER_ORDER_REF => 6, AmpSellerOrderTableMap::DISCOUNT => 7, AmpSellerOrderTableMap::POSTAGE => 8, AmpSellerOrderTableMap::POSTAGE_TAX => 9, AmpSellerOrderTableMap::STATUS_ID => 10, AmpSellerOrderTableMap::CREATED_AT => 11, AmpSellerOrderTableMap::UPDATED_AT => 12, AmpSellerOrderTableMap::VERSION => 13, AmpSellerOrderTableMap::VERSION_CREATED_AT => 14, AmpSellerOrderTableMap::VERSION_CREATED_BY => 15, ),
        self::TYPE_RAW_COLNAME   => array('ID' => 0, 'ORDER_ID' => 1, 'AMP_SELLER_ID' => 2, 'CUSTOMER_ID' => 3, 'ORDER_PRODUCT_ID' => 4, 'AMP_SELLER_ORDER_COUNTER' => 5, 'SELLER_ORDER_REF' => 6, 'DISCOUNT' => 7, 'POSTAGE' => 8, 'POSTAGE_TAX' => 9, 'STATUS_ID' => 10, 'CREATED_AT' => 11, 'UPDATED_AT' => 12, 'VERSION' => 13, 'VERSION_CREATED_AT' => 14, 'VERSION_CREATED_BY' => 15, ),
        self::TYPE_FIELDNAME     => array('id' => 0, 'order_id' => 1, 'amp_seller_id' => 2, 'customer_id' => 3, 'order_product_id' => 4, 'amp_seller_order_counter' => 5, 'seller_order_ref' => 6, 'discount' => 7, 'postage' => 8, 'postage_tax' => 9, 'status_id' => 10, 'created_at' => 11, 'updated_at' => 12, 'version' => 13, 'version_created_at' => 14, 'version_created_by' => 15, ),
        self::TYPE_NUM           => array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, )
    );

    /**
     * Initialize the table attributes and columns
     * Relations are not initialized by this method since they are lazy loaded
     *
     * @return void
     * @throws PropelException
     */
    public function initialize()
    {
        // attributes
        $this->setName('amp_seller_order');
        $this->setPhpName('AmpSellerOrder');
        $this->setClassName('\\ArtabanMarketplace\\Model\\AmpSellerOrder');
        $this->setPackage('ArtabanMarketplace.Model');
        $this->setUseIdGenerator(true);
        // columns
        $this->addPrimaryKey('ID', 'Id', 'INTEGER', true, null, null);
        $this->addForeignKey('ORDER_ID', 'OrderId', 'INTEGER', 'order', 'ID', true, null, null);
        $this->addForeignKey('AMP_SELLER_ID', 'AmpSellerId', 'INTEGER', 'amp_seller', 'ID', true, null, null);
        $this->addForeignKey('CUSTOMER_ID', 'CustomerId', 'INTEGER', 'customer', 'ID', true, null, null);
        $this->addColumn('ORDER_PRODUCT_ID', 'OrderProductId', 'VARCHAR', false, 1000, null);
        $this->addColumn('AMP_SELLER_ORDER_COUNTER', 'AmpSellerOrderCounter', 'INTEGER', true, null, null);
        $this->addColumn('SELLER_ORDER_REF', 'SellerOrderRef', 'VARCHAR', false, 100, null);
        $this->addColumn('DISCOUNT', 'Discount', 'DECIMAL', false, 16, 0);
        $this->addColumn('POSTAGE', 'Postage', 'DECIMAL', true, 16, 0);
        $this->addColumn('POSTAGE_TAX', 'PostageTax', 'DECIMAL', true, 16, 0);
        $this->addForeignKey('STATUS_ID', 'StatusId', 'INTEGER', 'amp_seller_order_status', 'ID', true, null, null);
        $this->addColumn('CREATED_AT', 'CreatedAt', 'TIMESTAMP', false, null, null);
        $this->addColumn('UPDATED_AT', 'UpdatedAt', 'TIMESTAMP', false, null, null);
        $this->addColumn('VERSION', 'Version', 'INTEGER', false, null, 0);
        $this->addColumn('VERSION_CREATED_AT', 'VersionCreatedAt', 'TIMESTAMP', false, null, null);
        $this->addColumn('VERSION_CREATED_BY', 'VersionCreatedBy', 'VARCHAR', false, 100, null);
    } // initialize()

    /**
     * Build the RelationMap objects for this table relationships
     */
    public function buildRelations()
    {
        $this->addRelation('Customer', '\\Thelia\\Model\\Customer', RelationMap::MANY_TO_ONE, array('customer_id' => 'id', ), 'RESTRICT', 'RESTRICT');
        $this->addRelation('AmpSeller', '\\ArtabanMarketplace\\Model\\AmpSeller', RelationMap::MANY_TO_ONE, array('amp_seller_id' => 'id', ), null, null);
        $this->addRelation('AmpSellerOrderStatus', '\\ArtabanMarketplace\\Model\\AmpSellerOrderStatus', RelationMap::MANY_TO_ONE, array('status_id' => 'id', ), 'RESTRICT', 'RESTRICT');
        $this->addRelation('Order', '\\Thelia\\Model\\Order', RelationMap::MANY_TO_ONE, array('order_id' => 'id', ), 'RESTRICT', 'RESTRICT');
        $this->addRelation('AmpSellerOrderDeliveryReference', '\\ArtabanMarketplace\\Model\\AmpSellerOrderDeliveryReference', RelationMap::ONE_TO_MANY, array('id' => 'order_seller_id', ), 'CASCADE', 'RESTRICT', 'AmpSellerOrderDeliveryReferences');
        $this->addRelation('AmpSellerOrderVersion', '\\ArtabanMarketplace\\Model\\AmpSellerOrderVersion', RelationMap::ONE_TO_MANY, array('id' => 'id', ), 'CASCADE', null, 'AmpSellerOrderVersions');
    } // buildRelations()

    /**
     *
     * Gets the list of behaviors registered for this table
     *
     * @return array Associative array (name => parameters) of behaviors
     */
    public function getBehaviors()
    {
        return array(
            'timestampable' => array('create_column' => 'created_at', 'update_column' => 'updated_at', ),
            'versionable' => array('version_column' => 'version', 'version_table' => '', 'log_created_at' => 'true', 'log_created_by' => 'true', 'log_comment' => 'false', 'version_created_at_column' => 'version_created_at', 'version_created_by_column' => 'version_created_by', 'version_comment_column' => 'version_comment', ),
        );
    } // getBehaviors()
    /**
     * Method to invalidate the instance pool of all tables related to amp_seller_order     * by a foreign key with ON DELETE CASCADE
     */
    public static function clearRelatedInstancePool()
    {
        // Invalidate objects in ".$this->getClassNameFromBuilder($joinedTableTableMapBuilder)." instance pool,
        // since one or more of them may be deleted by ON DELETE CASCADE/SETNULL rule.
                AmpSellerOrderDeliveryReferenceTableMap::clearInstancePool();
                AmpSellerOrderVersionTableMap::clearInstancePool();
            }

    /**
     * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     *
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, a serialize()d version of the primary key will be returned.
     *
     * @param array  $row       resultset row.
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM
     */
    public static function getPrimaryKeyHashFromRow($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        // If the PK cannot be derived from the row, return NULL.
        if ($row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)] === null) {
            return null;
        }

        return (string) $row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)];
    }

    /**
     * Retrieves the primary key from the DB resultset row
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, an array of the primary key columns will be returned.
     *
     * @param array  $row       resultset row.
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM
     *
     * @return mixed The primary key of the row
     */
    public static function getPrimaryKeyFromRow($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {

            return (int) $row[
                            $indexType == TableMap::TYPE_NUM
                            ? 0 + $offset
                            : self::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)
                        ];
    }

    /**
     * The class that the tableMap will make instances of.
     *
     * If $withPrefix is true, the returned path
     * uses a dot-path notation which is translated into a path
     * relative to a location on the PHP include_path.
     * (e.g. path.to.MyClass -> 'path/to/MyClass.php')
     *
     * @param boolean $withPrefix Whether or not to return the path with the class name
     * @return string path.to.ClassName
     */
    public static function getOMClass($withPrefix = true)
    {
        return $withPrefix ? AmpSellerOrderTableMap::CLASS_DEFAULT : AmpSellerOrderTableMap::OM_CLASS;
    }

    /**
     * Populates an object of the default type or an object that inherit from the default.
     *
     * @param array  $row       row returned by DataFetcher->fetch().
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType The index type of $row. Mostly DataFetcher->getIndexType().
                                 One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     * @return array (AmpSellerOrder object, last column rank)
     */
    public static function populateObject($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        $key = AmpSellerOrderTableMap::getPrimaryKeyHashFromRow($row, $offset, $indexType);
        if (null !== ($obj = AmpSellerOrderTableMap::getInstanceFromPool($key))) {
            // We no longer rehydrate the object, since this can cause data loss.
            // See http://www.propelorm.org/ticket/509
            // $obj->hydrate($row, $offset, true); // rehydrate
            $col = $offset + AmpSellerOrderTableMap::NUM_HYDRATE_COLUMNS;
        } else {
            $cls = AmpSellerOrderTableMap::OM_CLASS;
            $obj = new $cls();
            $col = $obj->hydrate($row, $offset, false, $indexType);
            AmpSellerOrderTableMap::addInstanceToPool($obj, $key);
        }

        return array($obj, $col);
    }

    /**
     * The returned array will contain objects of the default type or
     * objects that inherit from the default.
     *
     * @param DataFetcherInterface $dataFetcher
     * @return array
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function populateObjects(DataFetcherInterface $dataFetcher)
    {
        $results = array();

        // set the class once to avoid overhead in the loop
        $cls = static::getOMClass(false);
        // populate the object(s)
        while ($row = $dataFetcher->fetch()) {
            $key = AmpSellerOrderTableMap::getPrimaryKeyHashFromRow($row, 0, $dataFetcher->getIndexType());
            if (null !== ($obj = AmpSellerOrderTableMap::getInstanceFromPool($key))) {
                // We no longer rehydrate the object, since this can cause data loss.
                // See http://www.propelorm.org/ticket/509
                // $obj->hydrate($row, 0, true); // rehydrate
                $results[] = $obj;
            } else {
                $obj = new $cls();
                $obj->hydrate($row);
                $results[] = $obj;
                AmpSellerOrderTableMap::addInstanceToPool($obj, $key);
            } // if key exists
        }

        return $results;
    }
    /**
     * Add all the columns needed to create a new object.
     *
     * Note: any columns that were marked with lazyLoad="true" in the
     * XML schema will not be added to the select list and only loaded
     * on demand.
     *
     * @param Criteria $criteria object containing the columns to add.
     * @param string   $alias    optional table alias
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function addSelectColumns(Criteria $criteria, $alias = null)
    {
        if (null === $alias) {
            $criteria->addSelectColumn(AmpSellerOrderTableMap::ID);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::ORDER_ID);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::AMP_SELLER_ID);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::CUSTOMER_ID);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::ORDER_PRODUCT_ID);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::AMP_SELLER_ORDER_COUNTER);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::SELLER_ORDER_REF);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::DISCOUNT);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::POSTAGE);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::POSTAGE_TAX);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::STATUS_ID);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::CREATED_AT);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::UPDATED_AT);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::VERSION);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::VERSION_CREATED_AT);
            $criteria->addSelectColumn(AmpSellerOrderTableMap::VERSION_CREATED_BY);
        } else {
            $criteria->addSelectColumn($alias . '.ID');
            $criteria->addSelectColumn($alias . '.ORDER_ID');
            $criteria->addSelectColumn($alias . '.AMP_SELLER_ID');
            $criteria->addSelectColumn($alias . '.CUSTOMER_ID');
            $criteria->addSelectColumn($alias . '.ORDER_PRODUCT_ID');
            $criteria->addSelectColumn($alias . '.AMP_SELLER_ORDER_COUNTER');
            $criteria->addSelectColumn($alias . '.SELLER_ORDER_REF');
            $criteria->addSelectColumn($alias . '.DISCOUNT');
            $criteria->addSelectColumn($alias . '.POSTAGE');
            $criteria->addSelectColumn($alias . '.POSTAGE_TAX');
            $criteria->addSelectColumn($alias . '.STATUS_ID');
            $criteria->addSelectColumn($alias . '.CREATED_AT');
            $criteria->addSelectColumn($alias . '.UPDATED_AT');
            $criteria->addSelectColumn($alias . '.VERSION');
            $criteria->addSelectColumn($alias . '.VERSION_CREATED_AT');
            $criteria->addSelectColumn($alias . '.VERSION_CREATED_BY');
        }
    }

    /**
     * Returns the TableMap related to this object.
     * This method is not needed for general use but a specific application could have a need.
     * @return TableMap
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function getTableMap()
    {
        return Propel::getServiceContainer()->getDatabaseMap(AmpSellerOrderTableMap::DATABASE_NAME)->getTable(AmpSellerOrderTableMap::TABLE_NAME);
    }

    /**
     * Add a TableMap instance to the database for this tableMap class.
     */
    public static function buildTableMap()
    {
      $dbMap = Propel::getServiceContainer()->getDatabaseMap(AmpSellerOrderTableMap::DATABASE_NAME);
      if (!$dbMap->hasTable(AmpSellerOrderTableMap::TABLE_NAME)) {
        $dbMap->addTableObject(new AmpSellerOrderTableMap());
      }
    }

    /**
     * Performs a DELETE on the database, given a AmpSellerOrder or Criteria object OR a primary key value.
     *
     * @param mixed               $values Criteria or AmpSellerOrder object or primary key or array of primary keys
     *              which is used to create the DELETE statement
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
     public static function doDelete($values, ConnectionInterface $con = null)
     {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerOrderTableMap::DATABASE_NAME);
        }

        if ($values instanceof Criteria) {
            // rename for clarity
            $criteria = $values;
        } elseif ($values instanceof \ArtabanMarketplace\Model\AmpSellerOrder) { // it's a model object
            // create criteria based on pk values
            $criteria = $values->buildPkeyCriteria();
        } else { // it's a primary key, or an array of pks
            $criteria = new Criteria(AmpSellerOrderTableMap::DATABASE_NAME);
            $criteria->add(AmpSellerOrderTableMap::ID, (array) $values, Criteria::IN);
        }

        $query = AmpSellerOrderQuery::create()->mergeWith($criteria);

        if ($values instanceof Criteria) { AmpSellerOrderTableMap::clearInstancePool();
        } elseif (!is_object($values)) { // it's a primary key, or an array of pks
            foreach ((array) $values as $singleval) { AmpSellerOrderTableMap::removeInstanceFromPool($singleval);
            }
        }

        return $query->delete($con);
    }

    /**
     * Deletes all rows from the amp_seller_order table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public static function doDeleteAll(ConnectionInterface $con = null)
    {
        return AmpSellerOrderQuery::create()->doDeleteAll($con);
    }

    /**
     * Performs an INSERT on the database, given a AmpSellerOrder or Criteria object.
     *
     * @param mixed               $criteria Criteria or AmpSellerOrder object containing data that is used to create the INSERT statement.
     * @param ConnectionInterface $con the ConnectionInterface connection to use
     * @return mixed           The new primary key.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function doInsert($criteria, ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerOrderTableMap::DATABASE_NAME);
        }

        if ($criteria instanceof Criteria) {
            $criteria = clone $criteria; // rename for clarity
        } else {
            $criteria = $criteria->buildCriteria(); // build Criteria from AmpSellerOrder object
        }

        if ($criteria->containsKey(AmpSellerOrderTableMap::ID) && $criteria->keyContainsValue(AmpSellerOrderTableMap::ID) ) {
            throw new PropelException('Cannot insert a value for auto-increment primary key ('.AmpSellerOrderTableMap::ID.')');
        }


        // Set the correct dbName
        $query = AmpSellerOrderQuery::create()->mergeWith($criteria);

        try {
            // use transaction because $criteria could contain info
            // for more than one table (I guess, conceivably)
            $con->beginTransaction();
            $pk = $query->doInsert($con);
            $con->commit();
        } catch (PropelException $e) {
            $con->rollBack();
            throw $e;
        }

        return $pk;
    }

} // AmpSellerOrderTableMap
// This is the static code needed to register the TableMap for this table with the main Propel class.
//
AmpSellerOrderTableMap::buildTableMap();
